<!DOCTYPE html>
<html>

<head>
    <title>Task 38.30</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <!-- Import awesome-->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">


</head>

<body>
    <div class="container">
        <div class="text-center mt-4 mb-3">
            <h2>Dice History</h2>
        </div>
        <div class="jumbotron container">
            <div class="row form-group mb-0">
                <div class="col-sm-12">
                    <form>
                        <div class="form-row">
                            <h5>Player Information</h5>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-4">
                                <label>Username</label>
                                <input type="text" id="user-name" class="form-control bg-secondary text-white"
                                    disabled />
                            </div>
                            <div class="form-group col-md-4">
                                <label>Firstname</label>
                                <input type="text" id="first-name" class="form-control bg-secondary text-white"
                                    disabled />
                            </div>
                            <div class="form-group col-md-4">
                                <label>Lastname</label>
                                <input type="text" id="last-name" class="form-control bg-secondary text-white"
                                    disabled />
                            </div>
                        </div>
                    </form>
                </div>
            </div>
            <div id="log-result" class="mt-5"></div>
            <div class="mt-5">
                <table id="table-dice-history" class="table table-bordered table-striped table-hover">
                    <thead class="thead-dark">
                        <tr>
                            <th scope='col'>Game</th>
                            <th scope='col'>Dice</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>

            </div>
            <div class="col">
                <a href="task38.20 Filter User Table v2.1.html" class="nav justify-content-end">Back</a>
            </div>
        </div>
        <script>
            "use strict";
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
            var gPlayerInfoObj = {
                userName: "",
                firstName: "",
                lastName: ""
            };
            var gDiceHistoryData = [];

            var gNameCol = ["stt", "dice"];
            const gSTT_COL = 0;
            const gDICE_POINT_COL = 1;


            var gPlayerDataTable = $("#table-dice-history").DataTable({
                columns: [
                    { data: gNameCol[gSTT_COL] },
                    { data: gNameCol[gDICE_POINT_COL] },

                ], // Các thuộc tính của USER sẽ  match với từng column
                columnDefs: [
                    //định nghĩa các cột cần hiện ra
                    {
                        targets: gSTT_COL, //cột STT
                        className: "text-center text-primary",
                        render: function (data, type, row, meta) {
                            return meta.row + meta.settings._iDisplayStart + 1;
                        }
                    },
                    {
                        targets: gDICE_POINT_COL, //cột STT
                        className: "text-center text-primary",
                    },
                ]
            });
            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            $(document).ready(function () {
                onPageLoading();
            });

            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {//get data form query string
                var vCurrentURL = window.location.href;
                catchDataFormURL(vCurrentURL);
                loadPlayerInfoToForm(gPlayerInfoObj);
                getPlayerDiceHistory(gPlayerInfoObj.userName);
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
            //hàm xử lý thực hiện lấy queryString từ URL
            function catchDataFormURL(paramsCurrentURL) {
                "use strict";
                var vNewUrl = new URL(paramsCurrentURL);
                //get parameter
                var vUname = vNewUrl.searchParams.get("user_name");  //get parameter từ URL user_name là get trên URL
                var vFname = vNewUrl.searchParams.get("first_name");
                var vLname = vNewUrl.searchParams.get("last_name");
                console.log("username: " + vUname);
                //save to var global
                gPlayerInfoObj.userName = vUname;
                gPlayerInfoObj.firstName = vFname;
                gPlayerInfoObj.lastName = vLname;
                //show result to console
                console.log("Kết quả = " + JSON.stringify(gPlayerInfoObj, true, 2));

            }

            //hàm load lên form
            function loadPlayerInfoToForm(paramDataObj) {
                $("#user-name").val(paramDataObj.userName);
                $("#first-name").val(paramDataObj.firstName);
                $("#last-name").val(paramDataObj.lastName);

            }


            // function gọi API lấy lịch sử tung xúc xắc
            function getPlayerDiceHistory(paramUserName) {
                $.ajax({
                    url: gBASE_URL + "/dice-history?username=" + gPlayerInfoObj.userName,
                    async: false,
                    type: "GET",
                    dataType: 'json',
                    success: function (paramRes) {
                        if (paramRes.dices.length > 0) {
                            var vCount = 0;
                            while (vCount < paramRes.dices.length) {
                                var bDice = { 'game': vCount, 'dice': paramRes.dices[vCount] };
                                gDiceHistoryData.push(bDice);
                                vCount++;
                            }
                            displayDiceHistoryTable(gDiceHistoryData);
                        }
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
            }

            // function hiển thị table Dice History
            function displayDiceHistoryTable(paramDiceHistory) {
                gPlayerDataTable.clear();
                gPlayerDataTable.rows.add(paramDiceHistory);
                gPlayerDataTable.draw();
            }

        </script>
</body>

</html>